/*
* @nom et Prenom : NOUBI NGUIAM ERICA CAREINE           CODE_PERMANANT : NOUE70260200
* @nom et Prenom : LALONG JEAN THIERRY                  CODE_PERMANANT : LALJ01379200
* @nom et Prenom : TENMA YOUANCHI GUILLAUMAR ARTHUS     CODE_PERMANANT : TENG84350100
* @nom et Prenom : MBAH TANTOH DILAN                    CODE_PERMANANT : MBAD92300200
*/


#include "header.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>

/*
* @titre sommed
* @Description Fonction pour effectuer la sommation successive de 1/n pour n iterations (DP)
* @param : aucun paramettre en entr et aucun en sortie
*/
void sommed() {
    printf("Vous avez choisi la fonctionnalite iterations pour la sommation successive (DP)\n\n");
    printf("Entrez le nombre d'iterations pour la sommation : ");
    int n;
    do {
        printf("Entrez le nombre d'iterations pour la sommation multiple de 100 soit(100,1000,10000) : ");
        scanf("%d", &n);

        if (n != 100 && n != 1000 && n != 10000) {
            printf("Le nombre d'iterations doit etre un multiple de 100.\n");
        }
    } while (n != 100 && n != 1000 && n != 10000);

    double somme = 0.0;

    for (int i = 1; i <= n; i++) {
        somme += 1.0 / i;
    }

    double erreur1 = fabs(somme - log(n));//formule de calcul d'erreur
    double erreur2 = 1 - somme; //estimation d'erreur

    printf("\nNombre d'iterations (n) : %d\n", n);
    printf("Resultat de la sommation : %.15lf\n", somme);
    printf("Erreur1 de calcul : %.15lf\n", erreur1);
    printf("Erreur2 de calcul : %.15lf\n", erreur2);
}

/*
* @titre sommef
* @Description Fonction pour effectuer la sommation successive de 1/n pour n iterations (SP)
* @param : aucun paramettre en entr et aucun en sortie
*/
void sommef(){
    printf("Vous avez choisi la fonctionnalite iterations pour la sommation successive (SP)\n\n");
    printf("Entrez le nombre d'iterations pour la sommation : ");
    int n;
    do {
        printf("Entrez le nombre d'iterations pour la sommation multiple de 100 soit(100,1000,10000) : ");
        scanf("%d", &n);

        if (n != 100 && n != 1000 && n != 10000) {
            printf("Le nombre d'iterations doit etre un multiple de 100.\n");
        }
    } while (n != 100 && n != 1000 && n != 10000);

    float somme = 0.0;

    for (int i = 1; i <= n; i++) {
        somme = somme + (1.0 / i);
    }

    float erreur1 = fabs(somme - log(n));//formule de calcul d'erreur
    float erreur2 = 1 - somme; //estimation d'erreur

    printf("\nNombre d'iterations (n) : %d\n", n);
    printf("Resultat de la sommation : %10.15f\n", somme);
    printf("Erreur1 de calcul : %.15f\n", erreur1);
    printf("Erreur2 de calcul : %.15f\n", erreur2);
}
