/*
* @nom et Prenom : NOUBI NGUIAM ERICA CAREINE           CODE_PERMANANT : NOUE70260200
* @nom et Prenom : LALONG JEAN THIERRY                  CODE_PERMANANT : LALJ01379200
* @nom et Prenom : TENMA YOUANCHI GUILLAUMAR ARTHUS     CODE_PERMANANT : TENG84350100
* @nom et Prenom : MBAH TANTOH DILAN                    CODE_PERMANANT : MBAD92300200
*/


#include "header.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>

/*
* @titre sommeascf
* @Description Fonction sommeascf() pour (float) (SP)
* @param : aucun paramettre en entré et aucun en sortie
*/
void  sommeascf(){
     float sum = 0.0;

    for (int n = 1; n <= 3; n++) {
        sum = 0.0;
        for (int i = 1; i <= 32767; i++) {
            sum += 1.0 / pow((float)i, (float)n);
        }

        printf("Valeur de n : %d\n", n);
        printf("Resultat de la sommation ascendante pour SP (float) : %.20f\n", sum);
    }
}


/*
* @titre sommedescf
* @Description Fonction sommedescf() pour (float) (SP)
* @param : aucun paramettre en entré et aucun en sortie
*/
void sommedescf(){
     float sum = 0.0;

    for (int n = 1; n <= 3; n++) {
        sum = 0.0;
        for (int i = 32767; i >= 1; i--) {
            sum += 1.0 / pow((float)i, (float)n);
        }
        printf("Valeur de n : %d\n", n);
        printf("Resultat de la sommation descendante pour SP (float) : %.20f\n", sum);
    }
}


/*
* @titre sommeascd
* @Description Fonction sommeascd() pour (double) (DP)
* @param : aucun paramettre en entré et aucun en sortie
*/
void sommeascd(){
    double sum = 0.0;

    for (int n = 1; n <= 3; n++) {
        sum = 0.0;
        for (int i = 1; i <= 32767; i++) {
            sum += 1.0 / pow((double)i, (double)n);
        }
        printf("Valeur de n : %d\n", n);
        printf("Resultat de la sommation ascendante pour DP (double) : %.20lf\n", sum);
    }

}


/*
* @titre sommedescd
* @Description Fonction sommedescd() pour (double) (DP)
* @param : aucun paramettre en entré et aucun en sortie
*/
void sommedescd(){
    double sum = 0.0;

    for (int n = 1; n <= 3; n++) {
        sum = 0.0;
        for (int i = 32767; i >= 1; i--) {
            sum += 1.0 / pow((double)i, (double)n);
        }
        printf("Valeur de n : %d\n", n);
        printf("Resultat de la sommation descendante pour DP (double) : %.20lf\n", sum);
    }
}
