// Équipes Nom : CONSOLANT Ilunga &  ALTENOR John Borislove

// bibliothèques
#include<stdio.h>
#include<stdlib.h>
#include <math.h>

// Definition de constantes utiles
#define MAXIT 100
#define PI 3.14159
#define G 9.81 
#define PRECISIONX 0.00000000000000000001
#define PRECISIONZERO 0.0000000000000000001



void Menu();
void Traitement();
void Continue();
void additionSINT();
void epsilonf();
void epsilond();
void sommef(int N);
void sommed(int N);
void sommeascf(float n);
void sommedescf(float n);
void sommeascd(double n);
void sommedescd(double n);


double F(double x, double theta0, double v0, double y0);
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc);




int choix, continuer;
char* c;
int main()
{

	Menu();
	Traitement();

	return 0;
}

void Menu()
{
	// création du menu
	int choix;
	printf(" Les erreurs et precision des calculs par ordinateur");
	printf("\n------------------------------------------------- \n");
	printf("                    MENU");
	printf("\n------------------------------------------------- \n");
	printf("\n  1: Addition de deux short int (AdditionSINT)\n ");
	printf("\n  2: epsilonf reelle simple precision (SP) (float) \n     epsilond double precision (DP) (double)\n");
	printf("\n  3: somme succesive (float)\n");
	printf("\n  4: somme successive (double)\n");
	printf("\n  5: somme ascendante (float)\n");
	printf("\n  6: somme ascendante (double)\n");
	printf("\n  7: somme descendante (float)\n");
	printf("\n  8: somme descendante (double)\n");
	printf("\n  9: calcul de la distance parcourue en x\n");
	printf("\n------------------------------------------------- \n");
}

void Traitement() // traitement du choix entré par l'utilisateur 
{
	printf("\n \n");
	printf("Selectionnez le numero correspondant a votre choix : ");
	while (!scanf_s("%d", &choix))
	{
		printf(" \n Mauvaise selection entrez un nombre entre 1 a 9\n");
		scanf_s("%s", &c);
	}
	switch (choix)
	{
	case 1:
		printf("\n Vous avez selectionne l'additionSINT :\n");
		additionSINT();
		Continue();
		Menu();
		Traitement();
		break;
	case 2:
		printf("\n Vous avez selectionne epsilonf et epsilond:\n");
		epsilonf();
		epsilond();
		Continue();
		Menu();
		Traitement();
		break;

	case 3:
		printf(" Vous avez selectionne la somme flottante:");
		sommef(100);
		sommef(1000);
		sommef(10000);
		Continue();
		Menu();
		Traitement();
		break;
	case 4:
		printf(" Vous avez selectionne la somme double:");
		sommed(100);
		sommed(1000);
		sommed(10000);
		Continue();
		Menu();
		Traitement();
		break;
	case  5:
		printf(" Vous avez selectionne la somme ascendante flottante:");
		sommeascf(1);
		sommeascf(2);
		sommeascf(3);
		Continue();
		Menu();
		Traitement();
		break;
	case 6:
		printf(" Vous avez selectionne la somme ascendante double:");
		sommeascd(1);
		sommeascd(2);
		sommeascd(3);
		Continue();
		Menu();
		Traitement();
		break;
	case 7:
		printf(" Vous avez selectionne la somme descendante flottante:");
		sommedescf(1);
		sommedescf(2);
		sommedescf(3);
		Continue();
		Menu();
		Traitement();
		break;

	case 8:
		printf(" Vous avez selectionne la somme descendante double");
		sommedescd(1);
		sommedescd(2);
		sommedescd(3);
		Continue();
		Menu();
		Traitement();
		break;
	case 9:
		// Exemple d'appel permettant le calcul de la distance en x parcourue par une balle
		// Parametre 1 x1: borne inferieure des valeurs en x (m)
		// Parametre 2 x2: borne superieure des valeurs en x (m)
		// Parametre 3 theta0: angle en degre par rapport de la direction de la balle au depart
		// Parametre 4 v0: vitesse initiale (m/s)
		// Parametre 5 y0: hauteur de la balle au depart (m)
		// Parametre 6 xacc: precision sur la localisation de la racine en x
		// Parametre 7 zeroacc: précision sur la localisation du 0 de fonction (en y)

		printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));
		Continue();
		Menu();
		Traitement();
		break;


	}

}

// Continuez le traitement si vous voulez

void Continue()
{
	printf("Vous voulez continuer ? Oui tappez 1 sinon appuyez sur 0\n");
	while (!scanf_s("%d", &continuer))
	{
		printf("\n Votre choix est invalide, tappez 1 pour continuer ou sur 0 pour arreter \n");
		scanf_s("%s", &c);
	}
	switch (continuer)
	{
	case 1:
		Menu();
		Traitement();
		break;
	case 0:

		break;
	}
}

/*Cette fonction est appelée  additionSINT(),
Cette fonction devra afficher le résultat de
la somme et indiquer si ce résultat est correct
ou est  un débordement positif ou négatif.
Les paramètres en entrée (INPUT : n1, n2) et en sortie (OUTPUT : somme, débordement positif, débordement négatif)
*/

void additionSINT()
{
	short int n1 = 0, n2 = 0, somme;
	char a;
	printf("Saisissez le premier nombre signe (n1) : ");

	while (!scanf_s("%hd", &n1))
	{
		printf("\nSaisi invalide veuillez recommencer\t\n");
		scanf_s("%hd", &a);
	}

	printf("Saisissez le deuxieme nombre signe (n2) : ");

	while (!scanf_s("%hd", &n2))
	{
		printf("Saisi invalide veuillez recommencer");
		scanf_s("hd", &a);
	}

	somme = n1 + n2;

	if (n1 > 0 && n2 > 0 && somme < 0)
	{
		printf("\nDebordement positif");
		printf("\n n1 = %hd", n1);
		printf("\n n2 = %hd", n2);
		printf("\n n1 + n2 = %hd\n", somme);
	}
	else if (n2 < 0 && n1 < 0 && somme >= 0)
	{
		printf("\nDebordement negatif");
		printf("\n n1 = %hd", n1);
		printf("\n n2 = %hd", n2);
		printf("\n n1 + n2 = %hd\n", somme);
	}
	else
	{
		printf("\nResultat :");
		printf("\n n1 = %hd", n1);
		printf("\n n2 = %hd", n2);
		printf("\n n1 + n2 = %hd\n", somme);
	}
}

/*Ces fonctions sont appelée epsilonf et epsilond,
La fonction epsilonf est utilisée pour la représentation réelle simple précision (SP) (float)
et la fonction epsilond est utilisée pour la représentation double précision (DP) (double).
Ces fonctions doivent afficher la valeur du epsilon ainsi que le nombre de chiffres binaires significatifs

Les paramètres en entrée (INPUT : pas nécessaire)
et en sortie (OUTPUT : EPSILON (float), Nombre de chiffres significatifs (float), EPSILON (double), Nombre de chiffres significatifs (double))
*/

void epsilonf()
{
	float eps = 1, unpluseps;
	int n = 0;
	unpluseps = 1 + eps;
	while (unpluseps > 1)
	{
		eps = eps / 2;
		unpluseps = 1 + eps;
		n++;
	}
	eps = eps * 2;
	n = n - 1;
	printf("\n Epsilonf (SP) (float) : %20.23f00000000000000000 \n", eps);
	printf("\n nombre de chiffres binaires significatifs (SP) (float) est de : %d\n ", n);
}

void epsilond()
{
	double eps = 1, unpluseps;
	int n = 0;
	unpluseps = 1 + eps;
	while (unpluseps > 1)
	{
		eps = eps / 2;
		unpluseps = 1 + eps;
		n++;
	}
	eps = eps * 2;
	n = n - 1;
	printf("\n Epsilonf (DP) (double) : %20.32lf00000000\n", eps);
	printf("\n nombre de chiffres binaires significatifs (DP) (double) est de : %d\n ", n);
}


/*Cette fonction est appelée sommef,
La fonction sommef pour les nombres réels simple précision (SP)
Cette fonction doit afficher la valeur de n, le résultat de la sommation ainsi que l'erreur de calcul.

Les paramètres en entrée (INPUT : pas nécessaire) et en sortie (OUTPUT : somme successive (float), erreur (float) pour n=100/n=1000/n=10000)
*/


void   sommef(int N)
{
	float saut, somme = 0.0, erreur;
	int i;

	for (i = 1; i <= N; i++)
	{
		saut = 1.0 / N;
		somme += saut;
	}

	erreur = 1 - somme;
	printf("\n somme successive (float) = %20.17f0000000000000 Pour N= %d \n", somme, N);
	printf("\n erreur (float) = %20.23f0000000 Pour N=%d \n", erreur, N);

}


/*Cette fonction est appelée sommed,
La fonction sommed pour les nombres réels double précision (DP) (double).
Cette fonction doit afficher la valeur de n, le résultat de la sommation ainsi que l'erreur de calcul.

Les paramètres en entrée (INPUT : pas nécessaire) et en sortie (OUTPUT : somme successive (double), erreur (double) pour n=100/n=1000/n=10000)
*/

void sommed(int N)
{
	double saut, somme = 0.0, erreur;
	int i;

	for (i = 1; i <= N; i++)

	{
		saut = 1.0 / N;
		somme += saut;
	}

	erreur = 1 - somme;
	printf("\n somme successive (double) = %20.17lf0000000000000 Pour N= %d  \n", somme, N);
	printf("\n erreur (double) = %20.30lf Pour N = %d\n", erreur, N);
}


/*Cette fonction est appelée sommeascf,
La fonction sommeascf permet de faire la sommation ascendante pour les nombres réels simple précision (SP).
Cette fonction doit afficher la valeur de n et le résultat de la sommation.

Les paramètres en entrée (INPUT : pas nécessaire(puisque N=32767)) et en sortie (OUTPUT) : somme ascendante (float)
*/

void sommeascf(float n)
{
	int i, N = 32767;
	float somme = 0;

	for (i = 1; i <= N; i++)
	{

		somme += 1.0 / pow(i, n);
	}


	printf("\n somme asc (float) %20.15f0000000000000000 Pour n = %.6f \n", somme, n);


}

/*Cette fonction est appelée sommedescf,
La fonction sommedescf permet de faire la sommation descendante pour les nombres réels simple précision (SP).
Cette fonction doit afficher la valeur de n et le résultat de la sommation.

Les paramètres en entrée (INPUT : pas nécessaire(puisque N=32767)) et en sortie (OUTPUT) : somme descendante (float)
*/

void sommedescf(float n)
{
	int i, N = 32767;
	float somme = 0;

	for (i = 32767; i >= 1; i--)
	{

		somme += 1.0 / pow(i, n);

	}

	printf("\n somme desc (float) %20.15f0000000000000000 Pour n = %.6f \n", somme, n);
}


/*Cette fonction est appelée sommeascd,
La fonction sommeascd permet de faire la sommation ascendante pour les nombres réels double précision (DP).
Cette fonction doit afficher la valeur de n et le résultat de la sommation.

Les paramètres en entrée (INPUT : pas nécessaire(puisque N=32767)) et en sortie (OUTPUT) : somme ascendante (double)
*/

void sommeascd(double n)
{
	int i, N = 32767;
	double somme = 0;
	for (i = 1; i <= N; i++)
	{

		somme += 1.0 / pow(i, n);
	}


	printf("\n somme asc (double) %20.15lf0000000000000000 Pour n = %.6f \n", somme, n);
}

/*Cette fonction est appelée sommedescd,
La fonction sommedescd permet de faire la sommation descendante pour les nombres réels double précision (DP).
Cette fonction doit afficher la valeur de n et le résultat de la sommation.

Les paramètres en entrée (INPUT : pas nécessaire(puisque N=32767)) et en sortie (OUTPUT) : somme descendante (double)
*/

void sommedescd(double n)
{
	int i, N = 32767;
	double somme = 0;
	for (i = 32767; i >= 1; i--)
	{

		somme += 1.0 / pow(i, n);

	}

	printf("\n somme desc (double) %20.16lf0000000000000000 Pour n = %.6f \n", somme, n);
}


/*
Fonction qui calcule la valeur de la fonction parabolique, qui calcul la position y (hauteur) d'une balle sur sa
trajectoire en x
*/

double F(double x, double theta0, double v0, double y0)
{
	return (tan(theta0 * PI / 180.0) * x - ((G / (2.0 * v0 * v0 * cos(theta0 * PI / 180.0) * cos(theta0 * PI / 180.0))) * x * x) + y0);
}

/*
Fonction qui calcule la valeur de la position x  pour y = 0 donnant la distance parcourue  d'une balle
*/

double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
	int j;
	float dx, f, fmid, xmid, rtb;


	f = F(x1, theta0, v0, y0);
	fmid = F(x2, theta0, v0, y0);
	if (f * fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j, dx, fmid);
			return rtb;
		}
	}
	printf("Trop de bissections dans RTBIS\n");
}


