// prenom et nom: Mohamed Heni Baabaa            code permaneant: BAAM79260100
// prenom et nom: Ahmed Ammar                    code permaneant: AMMA66290400

#include <stdio.h>

// Fonction : epsilonf
// Description : Calcule l'epsilon machine pour les nombres flottants (float) et détermine le nombre de chiffres significatifs pour ce type de données.
// INPUT : Aucun
// OUTPUT : Aucun (affiche les résultats à l'écran)
void epsilonf()
{
    float epsilon = 1.0f;
    int n = 0;
    float unpluseps = 1.0f + epsilon;

    while (unpluseps > 1.0f)
    {
        epsilon /= 2.0f;
        unpluseps = 1 + epsilon;
        n++;
    }

    epsilon *= 2.0f;
    n-=1;

    printf("EPSILON (float) : %.30f\n", epsilon);
    printf("Nombre de chiffres significatifs (float): %d\n ", n);
}

// Fonction : epsilond
// Description : Calcule l'epsilon machine pour les nombres flottants double précision (double) et détermine le nombre de chiffres significatifs pour ce type de données.
// INPUT : Aucun
// OUTPUT : Aucun (affiche les résultats à l'écran)
void epsilond()
{
    double epsilon = 1.0;
    int n = 0;
    double unpluseps = 1.0 + epsilon;

    while (unpluseps > 1.0)
    {
        epsilon /= 2.0;
        unpluseps = 1 + epsilon;
        n++;
    }

    epsilon *= 2.0;
    n-=1;

    printf("EPSILON (double) : %.30lf\n", epsilon);
    printf("Nombre de chiffres significatifs (double): %d\n ", n);
}

int main()
{
    epsilonf();
    printf("\n");
    epsilond();
    return 0;
}