/********Mboko birghe breitzer*****************

La fonction sommef() calcule la somme de fractions en utilisant la simple prcision.
La fonction sommed() calcule la somme de fractions en utilisant la double prcision.
La fonction principale main() demande  l'utilisateur de saisir le nombre d'itrations,
vrifie si c'est un multiple de 100, puis appelle les fonctions sommef() et sommed() avec le nombre d'itrations spcifi.
*/
#include <stdio.h>

// Fonction pour calculer la somme de fractions pour un nombre donn d'itrations (simple prcision).
void sommef(int n) {
    float somme = 0.0f;  // Initialise la somme  0.0 en simple prcision.

    // Boucle pour calculer la somme de fractions successives.
    for (int i = 1; i <= n; ++i) {
        somme += 1.0f / i;
    }

    // Affiche le nombre d'itrations, le rsultat de la sommation et l'erreur de calcul.
    printf("Nombre d'itrations : %d\n", n);
    printf("Rsultat de la sommation (SP) : %g\n", somme);
    printf("Erreur de calcul (SP) : %g\n", 1.0f - somme);
}

// Fonction pour calculer la somme de fractions pour un nombre donn d'itrations (double prcision).
void sommed(int n) {
    double somme = 0.0;  // Initialise la somme  0.0 en double prcision.

    // Boucle pour calculer la somme de fractions successives.
    for (int i = 1; i <= n; ++i) {
        somme += 1.0 / i;
    }

    // Affiche le rsultat de la sommation et l'erreur de calcul.
    printf("Rsultat de la sommation (DP) : %g\n", somme);
    printf("Erreur de calcul (DP) : %g\n", 1.0 - somme);
}

// Fonction principale du programme.
int main() {
    int n;

    // Demande  l'utilisateur de saisir le nombre d'itrations (doit tre un multiple de 100) et vrifie la saisie.
    do {
        printf("Entrez un nombre d'itrations (multiple de 100) : ");
        scanf("%d", &n);

        if (n % 100 != 0) {
            printf("Veuillez entrer un nombre multiple de 100.\n");
        }
    } while (n % 100 != 0);

    sommef(n);  // Appelle la fonction sommef avec le nombre d'itrations spcifi.
    sommed(n);  // Appelle la fonction sommed avec le nombre d'itrations spcifi.

    return 0;
}
