/**********Mboko birghe breitzer****************

Le programme commence par inclure la bibliothque <stdio.h> qui fournit des fonctions d'entre/sortie standard.
Dfinition des fonctions de sommation :

Les quatre premires fonctions (sommeascf_SP, sommedescf_SP, sommeascf_DP, sommedescf_DP) calculent respectivement les sommes ascendantes et descendantes en simple prcision (SP) et double prcision (DP) des fractions 1/i pour i variant de 1  n.
Chaque fonction prend un paramtre entier n indiquant le nombre d'itrations  effectuer.
 l'intrieur de chaque fonction, une boucle for itre  travers les valeurs de i de 1  n ou de n  1 selon le type de sommation, et ajoute 1.0/i  une variable de somme.
Fonction main() :

La fonction principale du programme, main(), appelle chaque fonction de sommation avec diffrentes valeurs de n pour illustrer le calcul de la somme ascendante et descendante en simple et double prcision.
Les valeurs de n utilises dans les appels de fonctions sont 1, 2 et 3.
Affichage des rsultats :

Chaque fonction de sommation affiche le rsultat de la sommation correspondante  l'cran  l'aide de la fonction printf().
Retour 0 :

La fonction main() se termine par un return 0;, indiquant une excution russie du programme.
*/

    #include <stdio.h>

// Fonction de sommation ascendante pour nombres rels SP
void sommeascf_SP(int n) {
    float somme = 0.0f;
    for (int i = 1; i <= n; i++) {
        somme += 1.0f / i;
    }
    printf("n = %d, Somme ascendante (SP) = %f\n", n, somme);
}

// Fonction de sommation descendante pour nombres rels SP
void sommedescf_SP(int n) {
    float somme = 0.0f;
    for (int i = n; i >= 1; i--) {
        somme += 1.0f / i;
    }
    printf("n = %d, Somme descendante (SP) = %f\n", n, somme);
}

// Fonction de sommation ascendante pour nombres rels DP
void sommeascf_DP(int n) {
    double somme = 0.0;
    for (int i = 1; i <= n; i++) {
        somme += 1.0 / i;
    }
    printf("n = %d, Somme ascendante (DP) = %lf\n", n, somme);
}

// Fonction de sommation descendante pour nombres rels DP
void sommedescf_DP(int n) {
    double somme = 0.0;
    for (int i = n; i >= 1; i--) {
        somme += 1.0 / i;
    }
    printf("n = %d, Somme descendante (DP) = %lf\n", n, somme);
}

int main() {
    sommeascf_SP(1);
    sommedescf_SP(1);
    sommeascf_DP(1);
    sommedescf_DP(1);

    sommeascf_SP(2);
    sommedescf_SP(2);
    sommeascf_DP(2);
    sommedescf_DP(2);

    sommeascf_SP(3);
    sommedescf_SP(3);
    sommeascf_DP(3);
    sommedescf_DP(3);

    return 0;
}
