#include <stdio.h>
#include <stdlib.h>
#include "util-Rtbis-Trajectoire.cpp" // Importation du module util-Rtbis-Trajectoire
/*
programe sur le erreurs et precisions des calculs par ordinateur
auteurs
KENNE ZOYEM ROSLIN  KENZ82270400.
TCHAMBA MAKAMTE MARC OREL
FOMKOUNG TAGNE MICHAEL CEDRIC
MBODA RUDY
*/
void additionSINT();
void epsilonf();
void epsilond();
void sommef();
void sommed();
void sommeascf();
void sommeascd();
void sommedescf();
void sommedescd();
int main()
{
   additionSINT();
 epsilonf();
 epsilond();
 sommef();
 sommed();
 sommeascf();
 sommeascd();
 sommedescf();
 sommedescd();

    double xacc = PRECISIONX, zeroacc = PRECISIONZERO;


    printf("\n Valeur de la racine (bissection) = %lf m.\n", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));



    return 0;
}
// Fonction pour effectuer l'addition de deux nombres entiers signés 16 bits
void additionSINT() {
    printf("Entrez deux nombres entiers signés sur 16 bits:\n");
    short int n1, n2;
    scanf("%hd %hd", &n1, &n2);

    int sum = n1 + n2;

    printf("Résultat de l'addition : %d\n", sum);

    // Vérification du débordement positif et négatif
   if (n1>0 && n2>0 && sum<0) { // debordement +
		printf("\n Debordement positif : ");
		printf(" Resultat invalide : %d + %d = %d\n", n1, n2, sum);
	}
	else if (n1<0 && n2<0 && sum >= 0) {  // debordement �
		printf("\n Debordement negatif : ");
		printf(" Resultat invalide : %d + %d = %d\n", n1, n2, sum);
	}
	else
		printf("\n Resultat valide : %d + %d = %d", n1, n2, sum);
}
// Fonction pour évaluer l'epsilon de la représentation réelle simple précision
void epsilonf() {
    float eps = 1.0, unpluseps = 1 + eps;
    int n = 0;


    while (unpluseps > 1.0) {
        eps /= 2.0;
        unpluseps = 1 +eps;
        n++;
    }

    eps = eps * 2;
    n = n-1;

    printf("\nValeur de eps = %12.10f et n = %d\n", eps, n);
}

// Fonction pour évaluer l'epsilon de la représentation réelle double précision (DP)
void epsilond() {
    double eps = 1.0, unpluseps = 1 + eps;
    int n = 0;


    while (unpluseps > 1.0) {
        eps /= 2.0;
        unpluseps = 1 +eps;
        n++;
    }

    eps = eps * 2;
    n = n-1;

    printf("\nValeur de eps = %20.18lf et n = %d\n", eps, n);
}

// Fonction pour effectuer la sommation successive de 1/n en utilisant la représentation réelle simple précision (SP)
void sommef() {
    int n;
    float somme = 0.0;

    printf("Entrez un nombre entier multiple de 100 pour le nombre d'itérations (SP) :\n");
    scanf("%d", &n);

    // Validation de n pour vérifier s'il est un multiple de 100
    if (n % 100 != 0) {
        printf("Nombre d'itérations invalide. Doit être un multiple de 100.\n");
        return;
    }

    for (int i = 1; i <= n; i++) {
        somme += 1.0 / i;
    }

    printf("Nombre d'itérations : %d\n", n);
    printf("Résultat de la sommation (SP) : %f\n", somme);
    printf("Erreur de calcul (SP) : %f\n", (1.0 - somme));
}
// Fonction pour effectuer la sommation successive de 1/n en utilisant la représentation réelle double précision (DP)
void sommed() {
    int n;
    double somme = 0.0;

    printf("Entrez un nombre entier multiple de 100 pour le nombre d'itérations (DP) :\n");
    scanf("%d", &n);

    // Validation de n pour vérifier s'il est un multiple de 100
    if (n % 100 != 0) {
        printf("Nombre d'itérations invalide. Doit être un multiple de 100.\n");
        return;
    }

    for (int i = 1; i <= n; i++) {
        somme += 1.0 / i;
    }

    printf("Nombre d'itérations : %d\n", n);
    printf("Résultat de la sommation (DP) : %lf\n", somme);
    printf("Erreur de calcul (DP) : %lf\n", (1.0 - somme));
}

// Fonction pour effectuer la sommation ascendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle simple précision (SP)
void sommeascf() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        float somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = 1; j <= n; j++) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (SP) : %f\n", somme);
        printf("\n");
    }
}
// Fonction pour effectuer la sommation descendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle simple précision (SP)
void sommedescf() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        float somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = n; j >= 1; j--) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (SP) : %f\n", somme);
        printf("\n");
    }
}

// Fonction pour effectuer la sommation ascendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle double précision (DP)
void sommeascd() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        double somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = 1; j <= n; j++) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (DP) : %lf\n", somme);
        printf("\n");
    }
}

// Fonction pour effectuer la sommation descendante de (1/in) pour n = 1, 2 et 3 en utilisant la représentation réelle double précision (DP)
void sommedescd() {
    int exposants[] = {1, 2, 3};
    int taille = sizeof(exposants) / sizeof(exposants[0]);

    for (int i = 0; i < taille; i++) {
        int n = 32767;
        double somme = 0.0;

        printf("Exposant : %d\n", exposants[i]);

        for (int j = n; j >= 1; j--) {
            somme += 1.0 / j;
        }

        printf("Résultat de la sommation (DP) : %lf\n", somme);
        printf("\n");
    }
}


//void rtbis(){






/*double rtbis(double (*func)(double), double x1, double x2, int a, int b, int c, double PRECISIONX, double PRECISIONZERO) {
    const int JMAX = 40;
    double dx, xmid, rtb;
    double f = (*func)(x1);
    double fmid = (*func)(x2);

    if (f*fmid >= 0.0) {
        // Les valeurs en x1 et x2 ne renferment pas de zéro.
        return -1.0;
    }

    rtb = f < 0.0 ? (dx=x2-x1,x1) : (dx=x1-x2,x2);
    for (int j=0; j<JMAX; j++) {
        fmid = (*func)(xmid=rtb+(dx *= 0.5));
        if (fmid <= 0.0) rtb=xmid;
        if (fabs(dx) < PRECISIONX || fmid == PRECISIONZERO) return rtb;
    }
    // La méthode de la bissection n'a pas convergé.
    return -1.0;
}*/















