//
// Created by sebastien lato on 2024-02-08.
//
#include "io_utils.h"
#include <cstdio>

/**
 * @brief Effectue l'addition de deux nombres short et détecte les débordements.
 *
 * @details Cette fonction demande à l'utilisateur d'entrer deux nombres short,
 *          effectue l'addition et vérifie si un débordement se produit.
 *
 * INPUT: aucun (les valeurs sont lues depuis l'entrée standard)
 * OUTPUT: aucun (le résultat est affiché sur la sortie standard)
 */
void additionSINT() {
    short int n1, n2, n3;
    //int nbValide=0;
    printf("Introduire une premiere valeur short int n1: \n");
    n1 = lireShortValidationETConversion();
    printf("Introduire une seconde valeur short int n2: \n");
    n2 = lireShortValidationETConversion();
    n3 = n1 + n2;
    if (n1>0 && n2>0 && n3<0) { // debordement +
        printf("\n Debordement positif : ");
        printf(" Resultat invalide : %d + %d = %d\n", n1, n2, n3);
    }
    else if (n1<0 && n2<0 && n3 >= 0) {  // debordement -
        printf("\n Debordement negatif : ");
        printf(" Resultat invalide : %d + %d = %d\n", n1, n2, n3);
    }
    else
        printf("\n Resultat valide : %d + %d = %d", n1, n2, n3);
}
