//******************************************************************************************************
//
//                               TP1: SIF1053
//       Nom: Diallo           Prénom: Thierno Mamadou               Code permanent: DIAT73090000
//       Nom: Ibekwe           Prénom: Somtochukwu Franck            Code permanent: IBES64270300
//       Nom: Meuleye          Prénom: Fomo Audrey Stéphane          Code permanent: MEUA05059900
//
//*******************************************************************************************************

#include "fonction.h"
 

//LES DIFFERENTS OPTIONS IMPLEMENTEES DANS LE PROGRAMME
int main(){
    int choix;
    do{
        printf("\n");
        printf("---------------------------------------------------------------------------------------------------------------------\n");
        printf("                                    MENU                               \n");
        printf("1. Addition des nombres entiers signés sur 16 bits\n");
        printf("2. Une fonction epsilonf (single precision)(float)\n");
        printf("3. Une fonction epsilond (double precision)(double)\n");
        printf("4. Sommation successive de 1/n (single precision)\n");
        printf("5. Sommation successive de 1/n (double precision)\n");
        printf("6. Sommation ascendante de nombres réels simples (single precision)\n");
        printf("7. Sommation descendante de nombres réels simples (simple precision)\n");
        printf("8. Sommation ascendante de nombres réels doubles (double precision)\n");
        printf("9. Sommation descendante de nombres réels doubles (double precision)\n");
        printf("10. La distance horizontale parcourue par une balle (projectile) suivant une trajectoire parabolique\n");
        printf("---------------------------------------------------------------------------------------------------------------------\n");
        printf("\n");
        printf("Choix : ");
        scanf("%d", &choix);

        switch(choix)
        {
        case 1:
             additionSINT();
            break;
        case 2:
             epsilonf();
            break;
        case 3:
             epsilond();
            break;
        case 4:
             sommef(100);
             sommef(1000);
             sommef(10000);    
            break;
        case 5:
             sommed(100);
             sommed(1000);
             sommed(10000);       
            break;
        case 6:
             sommeascf(1);
             sommeascf(2);
             sommeascf(3);  
            break;
        case 7:
             sommeascd(1);
             sommeascd(2);
             sommeascd(3);
            break;
        case 8:
             sommedescf(1);
             sommedescf(2);
             sommedescf(3);
            break;
        case 9:
             sommedescd(1);
             sommedescd(2);
             sommedescd(3);
            break;
        case 10:
                double v0 = 50.0;  // Vitesse initiale du projectile (m/s)
                double y0 = 0.0;   // Hauteur initiale du projectile (m)
                double xacc = 1e-8; // Précision pour la distance horizontale
                double zeroacc = 1e-8; // Précision pour la valeur de F(theta) - x

               // Appel à rtbis avec différentes valeurs de précision
                double theta1 = rtbis(0.0, M_PI / 2, 0.5, v0, y0, xacc, zeroacc);
                double theta2 = rtbis(0.0, M_PI / 2, 0.5, v0, y0, 1e-10, 1e-10);
                double theta3 = rtbis(0.0, M_PI / 2, 0.5, v0, y0, 1e-12, 1e-12);

                if (theta1 != -1.0) {
                    double portee1 = F(xacc, theta1, v0, y0);
                    printf("\nAngle pour xacc=1e-8 : %lf, Portee : %lf\n", theta1, portee1);
                }

                if (theta2 != -1.0) {
                    double portee2 = F(xacc, theta2, v0, y0);
                    printf("Angle pour xacc=1e-10 : %lf, Portee : %lf\n", theta2, portee2);
                }

                if (theta3 != -1.0) {
                    double portee3 = F(xacc, theta3, v0, y0);
                    printf("Angle pour xacc=1e-12 : %lf, Portee : %lf\n", theta3, portee3);
                }
                break;
            case 11:
                printf("Au revoir!\n");
                break;
            default:
                printf("Choix invalide. Veuillez reessayer.\n");
        }
    } while (choix != 11);

    return 0;
        
}