/*
 ====================================================================================================
              TP1 : Architecture des ordinateurs
 Auteurs : [Ehui Assama : EHUA90530000],
           [Diomande Mahoua Ilma : DIOM92300400],
           [Alimatou Sow: Sowa84330100],
           [Houé Dicardie Precious Netty:HOUD72560400],
                    EXERCICE 3
 =====================================================================================================
 */
#include <stdio.h>
#include <stdint.h>

// QUESTION 3:
/*
 * sommef(): Calcule la sommation successive de 1/n pour n itérations en utilisant des nombres à virgule flottante à précision simple (SP).
 * INPUT :  Le nombre d'itérations. Il doit être un entier (int) et un multiple de 100 (soit 100, 1000, ou 10000).
 * OUTPUT : La fonction affiche le résultat de la sommation.
 */

void sommef(){
    int n;
    float somme = 0;
    

    printf("Veuillez fournir un nombre entre 100, 1000 et 10000: ");
    scanf("%d", &n);
    if (n != 100 && n != 1000 && n != 10000) {
        printf("Erreur : Entrée non valide.\n");
        return;
    }
    for(int i = 1; i <= n; i++) {
        somme += 1/(float)i;
    }
    float erreur = 1 - somme;
    printf("Pour n = %d, la somme en SP est %f et l'erreur est %f\n", n, somme, erreur);
}

/**
 * sommed() : Calcule la sommation successive de 1/n pour n itérations en utilisant des nombres à virgule flottante à double précision (DP).
 * INPUT : Le nombre d'itérations. Il doit être un entier (int) et un multiple de 100 (soit 100, 1000, ou 10000).
 * OUTPUT : La fonction affiche le résultat de la sommation.
 */

void sommed(){
    int n;
    double somme = 0;


    printf("Veuillez fournir un nombre entre 100, 1000 et 10000: ");
    scanf("%d", &n);
    if (n != 100 && n != 1000 && n != 10000) {
        printf("Erreur : Entrée non valide.\n");
        return;
    }
    for(int i = 1; i <= n; i++) {
        somme += 1/(double)i;
    }
    double erreur = 1 - somme;
    printf("Pour n = %d, la somme en DP est %f et l'erreur est %f\n", n, somme, erreur);
}

int main (){

sommed();
sommef();
    
}
