/*
 ======================================================================================================
              TP1 : Architecture des ordinateurs
 Auteurs : [Ehui Assama : EHUA90530000],
           [Diomande Mahoua Ilma : DIOM92300400],
           [Alimatou Sow: Sowa84330100],
           [Houé Dicardie Precious Netty:HOUD72560400],
                  EXERCICE 1
 
 =====================================================================================================
 */

#include <stdio.h>
#include <stdint.h>

/*
 * additionSINT Additionne deux nombres entiers signés sur 16 bits.
 *
 * Cette fonction prend deux nombres entiers signés sur 16 bits en entrée et retourne leur somme.
 * Elle vérifie également les débordements positifs et négatifs.
 *
 * n1 Le premier nombre à additionner. Type : short int.
 * n2 Le deuxième nombre à additionner. Type : short int.
 *
 *La somme de n1 et n2 est de type : short int.
 */
void additionSINT() {
    short int n1, n2;

    printf("Veuillez fournir un premier nombre entier : ");
    scanf("%hd", &n1);
     if (scanf("%hd", &n1) != 1) {
        printf("Erreur : Entrée non valide pour le premier nombre.\n");
        return;
     }
    printf("Veuillez fournir un deuxième nombre entier : ");
    scanf("%hd", &n2);
     if (scanf("%hd", &n2) != 1) {
        printf("Erreur : Entrée non valide pour le deuxieme nombre.\n");
        return;
     }
short int somme = n1+n2;

// Vérifier les débordements

    if (n1 > 0 && n2 > 0 && somme < 0) {
        printf("Il y a un débordement positif.\n");
    } else if (n1 < 0 && n2 < 0 && somme < 0) {
        printf("Il y a un débordement négatif.\n");
    } else {
        printf("La somme est : %hd\n", somme);
    }

    return;
}

int main(){

    additionSINT();
}



