									/*
                                        #MEMBRES DU GROUPE                  Code Permanent
                                        ISSA OUMAROU EL HADJI               OUMI25129901
                                        HALIROU AOUDOU MIDOU                AOUH63260000
                                        LINDSAY GABRIELLE TENE SIDJE        TENL78270200
                                        NURUDEEN ABIOLA FASHOLA             NURA25349801
                                    */


#include <stdio.h>
#include <math.h>

// Definition de constantes utiles
#define MAXIT 100
#define PI 3.14159
#define G 9.81 
//#define PRECISIONX 0.00000000000000000001
//#define PRECISIONZERO 0.0000000000000000001

		/*fonction inspiree de la fonction du fichier utilitaire util-Rtbis-Trajectoire.cpp
		 disponible dans le dossier Exemples du site ftp
		 */
double F(double x, double theta0, double v0, double y0)
{
	return (tan(theta0*PI/180.0)*x-((G/(2.0*v0*v0*cos(theta0*PI / 180.0)*cos(theta0*PI / 180.0)))*x*x)+y0);
}

double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
	int j;
	float dx, f, fmid, xmid, rtb;


	f = F(x1, theta0, v0, y0);
	fmid = F(x2, theta0, v0, y0);
	if (f*fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j,dx,fmid);
			return rtb;
		}
	}
	printf("Trop de bissections dans RTBIS\n");
}


		/*fonction principale 
		comme modification nous avons ajoute des lignes qui demande a entrer la 
		la nouvelle valeur des parametre PRECISIONX et PRECISIONZERO.
		*/


int main (){

    double PRECISIONX, PRECISIONZERO;
    printf("donnex les nouvelles valeurs de PRECISIONX \n");
    scanf("%lf",&PRECISIONX);
    printf("donnex les nouvelles valeurs de PRECISIONZERO \n");
    scanf("%lf",&PRECISIONZERO);

    printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, PRECISIONX, PRECISIONZERO));
    return 0;
}