#include <math.h>
#include <stdio.h>

//using namespace std;

void additionSINT();
void clearStdinBuffer();
short lireshortValidationetConversion();
void epsilonf();
void epsilond();
void sommef();
void sommed();
void sommeascf(float n);
void sommedescf(float n);
void sommeascd(double n);
void sommedescd(double n);

/*
fonction qui fait la somme des entiers signÃ©s
*/
void additionSINT()
{
    unsigned short int n1, n2, n3;
    int nbValide = 0;
    while (nbValide != 2)
    {
        printf("Introduire 2 valeurs short int: ");
        nbValide = scanf("%hd %hd", &n1, &n2);
        clearStdinBuffer();
    }

    n3 = n1 + n2;
    if (n1 > 0 && n2 > 0 && n3 < 0)
    {
        printf("debordement positif: ");
        printf(" Resultat invalide : %d + %d = %d\n", n1, n2, n3);
    }

    else if (n1 < 0 && n2 < 0 && n3 >= 0)
    {
        printf("debordement negatif: ");
        printf(" Resultat invalide : %d + %d = %d\n", n1, n2, n3);
    }

    else
        printf("\n Resultat valide : %d + %d = %d", n1, n2, n3);
}

void clearStdinBuffer()
{
    char c;
    while ((getchar()) != '\n' && c != '\r') {}
}

short lireshortValidationetConversion()
{
    char chaineaconvertir[100];
    int i, imin, nbCar = 0;
    int retVal = 0;
    int valide = 0;
    return 0;
}

/*
fonction qui Ã©value lâepsilon de lâarchitecture INTEL (simple precision)
*/
void epsilonf()
{
    float eps = 1;
    float unpluseps;
    int n = 0;

    unpluseps = 1 + eps;
    while (unpluseps > 1)
    {
        eps = eps / 2;
        unpluseps = 1 + eps;
        n = n + 1;
    }
    eps = eps * 2;
    n = n - 1;
    printf("EPSILON (float) : %20.23lf \n", eps);
    printf("Nombre de chiffres significatifs (float): n = %d \n", n);
}

/*
fonction qui Ã©value lâepsilon de lâarchitecture INTEL (double precision)
*/
void epsilond()
{
    double eps = 1;
    double unpluseps;
    int n = 0;

    unpluseps = 1 + eps;
    while (unpluseps > 1)
    {
        eps = eps / 2;
        unpluseps = 1 + eps;
        n = n + 1; 
    }
    eps = eps * 2;
    n = n - 1;

    printf("EPSILON (double) : %20.52lf \n", eps);
    printf("Nombre de chiffres significatifs (double): n = %d \n", n);
}

/*
fonction qui fait une sommation successive (simple precision)
*/
void sommef()
{
    int N;
    float saut;
    float somme = 0;
    float i;
    float reste;
    printf("Introduire un multiple de 100: ");
    scanf("%d", &N);
    reste = N % 100;
    if (reste != 0.0)
    {
        printf("Votre chiffre n'est pas un multiple de 100");
        return;
    }
    saut = 1 / (float)N;
    for (i = 0; i < N; i++)
    {
        somme = somme + saut;
    }

    printf("somme successive (float) : %20.52lf Pour N = %d \n", somme, N);
    printf("erreur (float) : %20.52lf Pour N = %d \n", (1 - somme), N);
}

/*
fonction qui fait une sommation successive (double precision)
*/
void sommed()
{
    int N;
    double saut;
    double somme = 0;
    double i;
    double reste;
    printf("Introduire un multiple de 100: ");
    scanf("%d", &N);
    reste = N % 100;
    if (reste != 0.0)
    {
        printf("Votre chiffre n'est pas un multiple de 100");
        return;
    }

    saut = 1 / (double)N;
    for (i = 0; i < N; i++)
    {
        somme = somme + saut;
    }

    printf("somme successive (double) : %20.52lf Pour N = %d \n", somme, N);
    printf("erreur (double) : %20.52lf Pour N = %d \n", (1 - somme), N);
}

/*
fonction qui fait une sommation ascendante des nombres reels SP
*/
void sommeascf(float n)
{
    float somme = 0;
    float N = 32767;
    float i;
    float a;
    for (    i = 1; i <= N; i++)
    {
        a = pow((double)i, (double)n);
        somme += 1 / a;
    }

    printf("\n  Somme asc (float) = %20.52f %f ", somme, n);
}

/*
fonction qui fait une sommation descendante des nombres reels SP
*/
void sommedescf(float n)
{
    float somme = 0;
    float N = 32767;
    float i;
    float a;
    for (i = N; i >= 1; i--)
    {
        a = pow((double)i, (double)n);
        somme += 1 / a;
    }

    printf("\n  Somme desc (float) = %20.52f %f ", somme, n);
}

/*
fonction qui fait une sommation ascendante des nombres reels DP
*/
void sommeascd(double n)
{
    double somme = 0;
    double N = 32767;
    double i;
    double a;
    for (i = 1; i <= N; i++)
    {
        a = pow((double)i, (double)n);
        somme += 1 / a;
    }

    printf("\n  Somme asc (double) = %20.52f %f ", somme, n);
}

/*
fonction qui fait une sommation descendante des nombres reels DP
*/
void sommedescd(double n)
{
    double somme = 0;
    double N = 32767;
    double i;
    double a;
    for (i = N; i >= 1; i--)
    {
        a = pow((double)i, (double)n);
        somme += 1 / a;
    }

    printf("\n  Somme desc (double) = %20.52f %f ", somme, n);
}
int main()
{
    char rep = 'y';
    while (rep == 'y')
    {
        additionSINT();
        printf("\nVoulez-vous verifier la somme de 2 shorts (y)? ");
        scanf(" %c", &rep);
        clearStdinBuffer();
    }

    printf("\n\n");
    epsilonf();
    printf("\n");
    epsilond();
    printf("\n\n");

    sommef();
    printf("\n");
    sommed();
    printf("\n\n");

    sommeascf(1);
    sommeascf(2);
    sommeascf(3);
    printf("\n\n");

    sommeascd(1);
    sommeascd(2);
    sommeascd(3);
    printf("\n\n");

    sommedescf(1);
    sommedescf(2);
    sommedescf(3);
    printf("\n\n");

    sommedescd(1);
    sommedescd(2);
    sommedescd(3);

    return 0;
}