/*
* @nom et Prenom : NOUBI NGUIAM ERICA CAREINE           CODE_PERMANANT : NOUE70260200
* @nom et Prenom : LALONG JEAN THIERRY                  CODE_PERMANANT : LALJ01379200
* @nom et Prenom : TENMA YOUANCHI GUILLAUMAR ARTHUS     CODE_PERMANANT : TENG84350100
* @nom et Prenom : MBAH TANTOH DILAN                    CODE_PERMANANT : MBAD92300200
*/


#include "header.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>

/*
* @titre epsilonf
* @Description Fonction pour evaluer l'epsilon de l'architecture Intel pour la representation reelle simple precision (SP)
* @param : aucun paramettre en entr et aucun en sortie
*/
void epsilonf() {
    printf("Vous avez choisi la fonctionnalite evaluer l'epsilon en simple precision (SP)\n\n");
    float epsilon = 1.0;
    int n = 0;
     float unPlusEps = 1.0 + epsilon;

    while (unPlusEps > 1.0) {
        epsilon = epsilon / 2.0;
        unPlusEps = 1.0 + epsilon;
        n++;
        //printf("n = %d = %12.10f\n",n,epsilon);
    }

    epsilon = epsilon * 2.0;
    n = n - 1;

    //int nbChiffres = -1 * log2f(epsilon);

    printf("Representation reelle simple precision (float) (SP) : %12.40f\n", epsilon);
    printf("Nombre de chiffres binaires significatifs pour SP (float) : %d\n", n);
    //printf("Nombre de chiffres binaires significatifs : %d\n", nbChiffres);
}



/*
* @titre epsilond
* @Description Fonction pour evaluer l'epsilon de l'architecture Intel pour la representation reelle double precision (DP)
* @param : aucun paramettre en entr et aucun en sortie
*/
void epsilond() {
    printf("Vous avez choisi la fonctionnalite evaluer l'epsilon en double precision (DP)\n\n");
    double epsilon = 1.0;

    int n = 0;
    double unPlusEps = 1.0 + epsilon;

    while (unPlusEps > 1.0) {
        epsilon = epsilon / 2.0;
        unPlusEps = 1.0 + epsilon;
        n++;
        //printf("n = %d = %20.18lf\n",n,epsilon);
    }

    epsilon = epsilon * 2.0;
    n = n - 1;

    //int nbChiffres = -1 * log2(epsilon);

    printf("Epsilon pour la representation reelle double precision (double) (DP) : %20.40f\n\n", epsilon);
    printf("Nombre de chiffres binaires significatifs pour DP (double) : %d\n", n);
    //printf("Nombre de chiffres binaires significatifs : %d\n", nbChiffres);
}
