/*
* @nom et Prenom : NOUBI NGUIAM ERICA CAREINE           CODE_PERMANANT : NOUE70260200
* @nom et Prenom : LALONG JEAN THIERRY                  CODE_PERMANANT : LALJ01379200
* @nom et Prenom : TENMA YOUANCHI GUILLAUMAR ARTHUS     CODE_PERMANANT : TENG84350100
* @nom et Prenom : MBAH TANTOH DILAN                    CODE_PERMANANT : MBAD92300200
*/


#include "header.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <limits.h>

//fonction pour effacer les tampons dentree
void clearStdinBuffer()
{
	char c;
	while ((c = getchar()) != '\n' && c != '\r') {}

}

// Fonction pour effacer la console pour reduire l'affichage et garder le visuel simpe
void effacerConsole() {
    printf("\033[2J\033[1;1H"); // Squence d'chappement ANSI pour effacer l'cran
}


/*
*Titre:
*Description:
*INPUT: aucun
*OUTPUT: valeur entiere short convertie
*/


// Fonction pour vrifier si un nombre est un nombre sign sur 16 bits
int estNombreSigne16Bits(int nombre) {
    if (nombre >= -32768 && nombre <= 32767) {
        return nombre;
    } else {
        printf("\nMauvaise valeur, elle doit etre comprise entre -32767 et 32767.\n");
        return -32769; // Retourne une valeur indiquant une erreur
    }
}


// Fonction pour lire un nombre sign sur 16 bits en rptant l'instruction de lecture
int lireNombreSigne16Bits() {
    int nombre = -32769;

    while (nombre == -32769) {
        printf("Veuillez saisir un nombre signer sur 16 bits : ");
        scanf("%d", &nombre);

        nombre = estNombreSigne16Bits(nombre);
    }

    return nombre;
}


/*
*Titre: retourMenu
*Description: permet  l'utilisateur de revenir au menu principal ou de sortir du programme
*INPUT: aucun
*OUTPUT: aucun
*/
void retourMenu(){
    char reponse[10];
    do {
        printf("\n\n\nSouhaitez-vous revenir au menu ? (o/n) : ");
        scanf("%s", reponse);

        if (strcmp(reponse, "o") == 0) {
            // Rappeler la fonction du menu
            effacerConsole();
            menuPrincipal();
            contenuMenuSwitch();
        } else if (strcmp(reponse, "n") == 0) {
            // Quitter le programme
            printf("\nSortie du programme.\n");
            exit(0);
        } else {
            printf("Rponse invalide. Veuillez rpondre par 'o' ou 'n'.\n");
        }

    } while (1);
}
