//SENY FAYE***FAYS84060300***
// Definition de constantes utiles
#define MAXIT 100
#define g 9.81
#define M_PI 3.14159265358979323846
#define PRECISIONX
#define PRECISIONZ
#include <stdio.h>
#include <math.h>

double x,y,v0,theta0,x1,x2;
double F(double x, double theta0, double v0, double y0)
{
    return(tan(theta0*M_PI/180.0)*x-((g/(2.0*v0*v0*cos(theta0*M_PI/180.0)*cos(theta0*M_PI/180.0)))*x*x)+y0);
}
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
    int  j;
    double dx, f, fmid, xmid, rtb;
    f = F(x1, theta0, v0, y0);
	fmid = F(x2, theta0, v0, y0);
	if (f*fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = F(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j,dx,fmid);
			return rtb;
		}
	}
	printf("Trop de bissections dans RTBIS\n");
}
int main(){
    double v0=50.0; // Vitesse initiale 
    double y0=0.0;// Hauteur initiale
    double xacc=1e-8;// Precision Distance Horizontale

    double theta1=rtbis(0.0, M_PI/2,0.5,v0,y0,xacc,zeroacc);
    double theta2=rtbis(0.0, M_PI/2,0.5,v0,y0,1e-10,1e-10);
    double theta3=rtbis(0.0, M_PI/2,0.5,v0,y0,1e-12,1e-12);

    if(theta1!=-1.0){
        double portee1=F(xacc,theta1,v0,y0);
        printf("\n Angle de xacc=1e-8:%lf,portee:%lf\n", theta1,portee1);
    }
    if(theta2!=-1.0){
        double portee2=F(xacc,theta2,v0,y0);
        printf("\n Angle de xacc=1e-10:%lf,portee:%lf\n", theta2,portee2);
    }
    if(theta3!=-1.0){
        double portee3=F(xacc,theta3,v0,y0);
        printf("\n Angle de xacc=1e-12:%lf,portee:%lf\n", theta3,portee3);
    }
double F();
double rtbis();

}