#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <limits.h>
#include <float.h>
void additionInt();
void epsilonf();
void epsilond();
void sommef();
void sommed();
void sommeasf();
void sommedessf();
void sommeasd();
void sommedessd();
double F(double x);
double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc);
double hauteur(double x, double theta0, double v0, double y0);

#define MAXIT 100
#define PI 3.14159
#define G 9.81 
#define PRECISIONX 0.00000000000000000001
#define PRECISIONZERO 0.0000000000000000001

 int main()
 {
 	/*Auteur: MADIEGA Michel(MADY77340100)
          SAVADOGO Abdoul Azize(SAVA66320300)
		KEYANFE DONGMO ANASTASIE ANGE(KEYA87330300)*/


 	printf("Cas de l'addition des Int \n\n");
 	additionInt();
 	printf("\n\nCas de l'epsilon float \n\n");
 	epsilonf();
 	printf("\n\nCas de l'epsilon Double \n\n");
 	epsilond();
 	printf("\n\nCas de la somme float \n\n");
 	sommef();
 	printf("\n\nCas de la somme double  \n\n");
 	sommed();
 	printf("\n\nCas de la somme ascendante float  \n\n");
	sommeasf ();
	printf("\n\nCas de la somme descendante float \n\n");
	sommedessf();
	printf("\n\nCas de la somme ascendante double \n\n");
	sommeasd();
	printf("\n\nCas de la somme descendante double \n\n");
	sommedessd();
	printf("\n\nCas de la trajectoire parabolique \n\n");
	printf("\n Valeur de la racine (bissection) = %lf m.", rtbis(1, 300, 30, 50, 2, 0.0000000000000000000001, 0.0000000000000000000001));
	

 	
    return 0;
}
//addition de deux short et debordement
void additionInt ()
 { 
    int m1,m2;
	short int n1,n2;  
	short int somme; 
	int a , b ,c;
	printf("Entrez un nombre compris entre %hd et %hd :",SHRT_MAX,SHRT_MIN);
	scanf ("%d",&m1);
	while (m1<SHRT_MIN || m1>SHRT_MAX)
	{
		printf("Entrez un nombre compris entre %hd et %hd car le nombre que vous venez d'entrer est incorrect:",SHRT_MAX,SHRT_MIN);
	    scanf ("%d",&m1);
	}
	n1=(short)m1;
	printf("Entrez un nombre compris entre %hd et %hd :",SHRT_MAX,SHRT_MIN);
	scanf ("%d",&m2);
	while (m2<SHRT_MIN || m2>SHRT_MAX){
		printf("Entrez un nombre compris entre %hd et %hd car le nombre que vous venez d'entrer est incorrect:",SHRT_MAX,SHRT_MIN);
	    scanf ("%d",&m2);
	}
	n2=(short)m2;
	somme =n1+n2;
    printf("la somme de %hd et %hd = %hd \n" ,n1,n2,somme);
    if ((n1>0 && n2>0 && somme<0) || (n1<0 && n2<0 && somme>0) )
    {
        if ((n1>0 && n2>0 && somme<0) )
         {
    	 printf("il ya eu un debordement positif \n");
         }
	    else if (n1<0 && n2<0 && somme>0)
	     {
        	printf("il ya eu un debordement positif \n");	
         }
	}
	else
    printf("Le resultat est correct\n ");
    	   
	 
 }
 // epsilon est la plus petite valmeur ajoute qui ne modifie pas la valeur du nombre entr�
 // Tant que la valeur ajoute apres la virgule � 1 change considerablement la valeur de 1 pour un type float(simple presicion l'algorithme continu son calcul jusqu'a atteindre epsilon 
//cas d'un float
 void epsilonf(){
    float epsilon =1;
	int nbreDebit= FLT_MANT_DIG;
    while (1+epsilon>1){
    	epsilon = epsilon/2;
    	
	}
	printf ("\n l'epsilon d'un float (nombre a virgule flottante soimple precision) est :%e",epsilon);
	printf ("\n il est sur %d bit",nbreDebit);
	

}
//cas d'un float
void epsilond(){
    double epsilon =1;
	int nbreDebit= DBL_MANT_DIG;
    while (1+epsilon>1){
    	epsilon = epsilon/2;
    	
	}
	printf ("\n l'epsilon d'un type double (nombre a virgule flottante double precision) est :%e",epsilon);
	printf ("\n il est sur %d bit",nbreDebit);
}	
//sommef: sommation successive flottante de 1/N
void sommef(){
	float somme=0 ;
	float erreur; 
	int n,i; 
	printf("\n entrez un nombre multiple de 100:");
	scanf("%d",&n);
	while(n % 100!= 0){
		printf("entrez un nombre correct (ce nombre doit etre un multiple de 100): \n");
		scanf("%d",&n);
	}
    printf("le nombre d'iteration est de : %d",n);
	for(i=1 ; i<=n ; i++)
	{
		somme += 1.0/n;
		printf("\n somme 1/%d = %f  %d ",n,somme,i);
	
	}
	erreur=1.0-somme;
	printf("\n L'erreur est de  %g",erreur);
}
//sommed: sommation successive double de 1/N 
void sommed(){
	double somme=0 ;
	double erreur; 
	int n,i; 
	printf("\n entrez un nombre multiple de 100:");
	scanf("%d",&n);
	while(n % 100 != 0){
		printf("entrez un nombre correct (ce nombre doit etre un multiple de 100): \n");
		scanf("%d",&n);
	}
    printf("le nombre d'iteration est de : %d",n);
	for(i=1 ; i<=n ; i++)
	{
		somme += 1.0/n;
		printf("\n somme 1/%d =  %lf  %i",n,somme,i);
	 
	}
	erreur=1.0-somme;
	printf("\n L'erreur est de  %e",erreur);
}
//sommeascf: sommation ascendante flottante de 1/i^n
void sommeasf()
{
	float somme =0;
	int n ; 
	int i; 
	float erreur;
	
	for (n=1;n<=3;n++)
	{
		for (i=1;i<=32767;i++){
		somme+=1.0/pow(i,n);;
		
		}
		printf("\n somme pour n =%d est %f",n,somme);
		erreur =fabs(somme-log(32767));
	    printf("\n l'erreur est de %e ",erreur);
	
	}

}

//sommedescf: sommation descendante flottante de 1/i^n
void sommedessf()
{
	float somme =0;
	int n ; 
	int i; 
	float erreur;
	
	for (n=1;n<=3;n++)
	{
		for (i=32767;i>=1;i--)
		{
		somme+=1.0/pow(i,n);;
		}
		printf("\n somme pour n =%d est %f",n,somme);
		erreur =fabs(somme-log(32767));
	    printf("\n l'erreur est de %e ",erreur);
	
	}
	
}
//somme successive assendante de 1/i^n n fois avec erreur de precision sur les calculs
void sommeasd()
{
	double somme =0;
	int n ; 
	int i;
	double erreur; 
	
	for (n=1;n<=3;n++)
	{
		for (i=1;i<=32767;i++)
		{
		somme +=1.0/pow(i,n);
		}
		
		printf("\n somme pour n =%d est %lf",n,somme);
		erreur =fabs(somme-log(32767));
	    printf("\n l'erreur est de %e ",erreur);
	
	}
	
}
//sommedescd: sommation descendante double de 1/i^n
void sommedessd()
{
	double somme =0;
    int n ; 
	int i; 
	double erreur;
	
	for (n=1;n<=3;n++)
	{
		for (i=32767;i>=1;i--)
		{
		somme+=1.0/pow((double)i,(double)n);;
		}
		printf("\n somme pour n =%d est %lf",n,somme);
		erreur =fabs(somme-log(32767));
	    printf("\n l'erreur est de %e ",erreur);
		
	}
	
}
/*
Fonction qui calcule la valeur de la fonction parabolique, qui calcul la position y (hauteur) d'une balle sur sa
trajectoire en x
*/
double hauteur(double x, double theta0, double v0, double y0)
{
	return (tan(theta0*PI/180.0)*x-((G/(2.0*v0*v0*cos(theta0*PI / 180.0)*cos(theta0*PI / 180.0)))*x*x)+y0);
}
//calcul de la distance horizontal parcourue entre x1 position initiale et x2 position finale estim�e

double rtbis(double x1, double x2, double theta0, double v0, double y0, double xacc, double zeroacc)
{
	int j;
	float dx, f, fmid, xmid, rtb;


	f = hauteur(x1, theta0, v0, y0);
	fmid = hauteur(x2, theta0, v0, y0);
	if (f*fmid >= 0.0) printf("Racine absente de cet intervalle dans RTBIS\n");
	rtb = f < 0.0 ? (dx = x2 - x1, x1) : (dx = x1 - x2, x2);
	for (j = 1; j <= MAXIT; j++) {
		fmid = hauteur(xmid = rtb + (dx *= 0.5), theta0, v0, y0);
		if (fmid <= 0.0) rtb = xmid;
		if (fabs(dx) < xacc || fabs(fmid) < zeroacc)
		{
			printf("\nNombre d'iterations: %d dx: %17.15lf f(rtb): %17.15lf", j,dx,fmid);
			return rtb;
		}
	}
	printf("Trop de bissections dans RTBIS\n");
};



