// prenom et nom: Mohamed Heni Baabaa            code permaneant: BAAM79260100
// prenom et nom: Ahmed Ammar                    code permaneant: AMMA66290400

#include <stdio.h>
#include <math.h>

// Fonction : sommeascf
// Description : Calcule la somme ascendante d'une série pour les flottants (float).
// INPUT : Aucun
// OUTPUT : Aucun (affiche les résultats à l'écran)
void sommeascf()
{
  int n = 1;
  for (int j = 1; j <= 3; j++)
  {
    float sum = 0.0f;

    for (int i = 1; i <= 32767; i++)
    {
      sum += 1.0f / powf(i, n);
    }
    printf("Somme asc (float) :%.30f %d\n", sum, n);
    n++;
  }
}

// Fonction : sommeascd
// Description : Calcule la somme ascendante d'une série pour les doubles (double).
// INPUT : Aucun
// OUTPUT : Aucun (affiche les résultats à l'écran)
void sommeascd()
{
  int n = 1;
  for (int j = 1; j <= 3; j++)
  {
    double sum = 0.0;

    for (int i = 1; i <= 32767; i++)
    {
      sum += 1.0 / pow(i, n);
    }
    printf("Somme asc (double) :%.30lf %d\n", sum, n);
    n++;
  }
}

// Fonction : sommedescf
// Description : Calcule la somme descendante d'une série pour les flottants (float).
// INPUT : Aucun
// OUTPUT : Aucun (affiche les résultats à l'écran)
void sommedescf()
{
  int n = 1;
  for (int j = 1; j <= 3; j++)
  {
    float sum = 0.0f;

    for (int i = 32767; i >= 1; i--)
    {
      sum += 1.0f / powf(i, n);
    }
    printf("Somme desc (float) :%.30f %d\n", sum, n);
    n++;
  }
}

// Fonction : sommedescd
// Description : Calcule la somme descendante d'une série pour les doubles (double).
// INPUT : Aucun
// OUTPUT : Aucun (affiche les résultats à l'écran)
void sommedescd()
{
  int n = 1;
  for (int j = 1; j <= 3; j++)
  {
    double sum = 0.0;

    for (int i = 32767; i >= 1; i--)
    {
      sum += 1.0 / pow(i, n);
    }
    printf("Somme desc (double) :%.30lf %d\n", sum, n);
    n++;
  }
}

int main()
{
  printf("\n");
  sommeascf();

  printf("\n");
  sommeascd();

  printf("\n");
  sommedescf();

  printf("\n");
  sommedescd();

  return 0;
}
