 /*Mboko birghe breitzer

  Fonction : additionSINT
 Description : Effectue l'addition de deux nombres entiers signs sur 16 bits.
 Dtecte les dbordements positifs et ngatifs.

 INPUT :
   hort int n1 - Premier nombre entier sign sur 16 bits fourni par l'utilisateur.
 *short int n2 - Deuxime nombre entier sign sur 16 bits fourni par l'utilisateur.

 *OUTPUT :Affiche le rsultat de l'addition et indique s'il y a un dbordement.
 */
#include <stdio.h>           // Inclut la bibliothque stdio.h, qui fournit les fonctionnalits d'entre/sortie standard en C.
#include <limits.h>          // Inclut la bibliothque limits.h pour obtenir des informations sur les limites des types de donnes entiers.

// Fonction pour additionner deux nombres entiers signs sur 16 bits et dtecter les dbordements.
void additionSINT() {
    short int n1, n2;  // Dclare deux variables locales de type short int pour stocker les nombres fournis par l'utilisateur.
    int sum;           // Dclare une variable locale de type int pour stocker le rsultat de l'addition.

    // Demande  l'utilisateur de fournir deux nombres entiers signs.
    printf("Entrez le premier nombre entier signe sur 16 bits : ");
    scanf("%hi", &n1);
    printf("Entrez le deuxieme nombre entier signe sur 16 bits : ");
    scanf("%hi", &n2);

    // Additionne les deux nombres.
    sum = n1 + n2;

    // Affiche le rsultat de l'addition.
    printf("Resultat de la somme : %d\n", sum);

    // Vrifie les dbordements positifs et ngatifs.
    if ((n1 > 0 && n2 > 0 && sum < 0) || (n1 < 0 && n2 < 0 && sum > 0)) {
        printf("Debordement detecte : Resultat invalide.\n");
    } else {
        printf("Resultat valide.\n");
    }
}

// Fonction principale du programme.
int main() {
    additionSINT();  // Appelle la fonction additionSINT() pour effectuer l'addition et dtecter les dbordements.

    return 0;  // Termine le programme.
}
